// Code generated by pulumi-language-go DO NOT EDIT.
// *** WARNING: Do not edit by hand unless you're certain you know what you are doing! ***

package pvecluster

import (
	"context"
	"reflect"

	"errors"
	"github.com/pulumi/pulumi/sdk/v3/go/pulumi"
	"internal"
)

type Cluster struct {
	pulumi.CustomResourceState

	Chunks      ChunkConfigPtrOutput     `pulumi:"chunks"`
	Config      ClusterConfigPtrOutput   `pulumi:"config"`
	Connection  ConnectionOutput         `pulumi:"connection"`
	DeviceClass pulumi.StringPtrOutput   `pulumi:"deviceClass"`
	Name        pulumi.StringOutput      `pulumi:"name"`
	NodeIds     pulumi.StringArrayOutput `pulumi:"nodeIds"`
	Replicas    pulumi.IntPtrOutput      `pulumi:"replicas"`
	Status      pulumi.StringOutput      `pulumi:"status"`
}

// NewCluster registers a new resource with the given unique name, arguments, and options.
func NewCluster(ctx *pulumi.Context,
	name string, args *ClusterArgs, opts ...pulumi.ResourceOption) (*Cluster, error) {
	if args == nil {
		return nil, errors.New("missing one or more required arguments")
	}

	if args.Connection == nil {
		return nil, errors.New("invalid value for required argument 'Connection'")
	}
	if args.Name == nil {
		return nil, errors.New("invalid value for required argument 'Name'")
	}
	if args.NodeIds == nil {
		return nil, errors.New("invalid value for required argument 'NodeIds'")
	}
	opts = internal.PkgResourceDefaultOpts(opts)
	var resource Cluster
	err := ctx.RegisterResource("pvecluster:index:Cluster", name, args, &resource, opts...)
	if err != nil {
		return nil, err
	}
	return &resource, nil
}

// GetCluster gets an existing Cluster resource's state with the given name, ID, and optional
// state properties that are used to uniquely qualify the lookup (nil if not required).
func GetCluster(ctx *pulumi.Context,
	name string, id pulumi.IDInput, state *ClusterState, opts ...pulumi.ResourceOption) (*Cluster, error) {
	var resource Cluster
	err := ctx.ReadResource("pvecluster:index:Cluster", name, id, state, &resource, opts...)
	if err != nil {
		return nil, err
	}
	return &resource, nil
}

// Input properties used for looking up and filtering Cluster resources.
type clusterState struct {
}

type ClusterState struct {
}

func (ClusterState) ElementType() reflect.Type {
	return reflect.TypeOf((*clusterState)(nil)).Elem()
}

type clusterArgs struct {
	Chunks      *ChunkConfig   `pulumi:"chunks"`
	Config      *ClusterConfig `pulumi:"config"`
	Connection  Connection     `pulumi:"connection"`
	DeviceClass *string        `pulumi:"deviceClass"`
	Name        string         `pulumi:"name"`
	NodeIds     []string       `pulumi:"nodeIds"`
	Replicas    *int           `pulumi:"replicas"`
}

// The set of arguments for constructing a Cluster resource.
type ClusterArgs struct {
	Chunks      ChunkConfigPtrInput
	Config      ClusterConfigPtrInput
	Connection  ConnectionInput
	DeviceClass pulumi.StringPtrInput
	Name        pulumi.StringInput
	NodeIds     pulumi.StringArrayInput
	Replicas    pulumi.IntPtrInput
}

func (ClusterArgs) ElementType() reflect.Type {
	return reflect.TypeOf((*clusterArgs)(nil)).Elem()
}

type ClusterInput interface {
	pulumi.Input

	ToClusterOutput() ClusterOutput
	ToClusterOutputWithContext(ctx context.Context) ClusterOutput
}

func (*Cluster) ElementType() reflect.Type {
	return reflect.TypeOf((**Cluster)(nil)).Elem()
}

func (i *Cluster) ToClusterOutput() ClusterOutput {
	return i.ToClusterOutputWithContext(context.Background())
}

func (i *Cluster) ToClusterOutputWithContext(ctx context.Context) ClusterOutput {
	return pulumi.ToOutputWithContext(ctx, i).(ClusterOutput)
}

type ClusterOutput struct{ *pulumi.OutputState }

func (ClusterOutput) ElementType() reflect.Type {
	return reflect.TypeOf((**Cluster)(nil)).Elem()
}

func (o ClusterOutput) ToClusterOutput() ClusterOutput {
	return o
}

func (o ClusterOutput) ToClusterOutputWithContext(ctx context.Context) ClusterOutput {
	return o
}

func (o ClusterOutput) Chunks() ChunkConfigPtrOutput {
	return o.ApplyT(func(v *Cluster) ChunkConfigPtrOutput { return v.Chunks }).(ChunkConfigPtrOutput)
}

func (o ClusterOutput) Config() ClusterConfigPtrOutput {
	return o.ApplyT(func(v *Cluster) ClusterConfigPtrOutput { return v.Config }).(ClusterConfigPtrOutput)
}

func (o ClusterOutput) Connection() ConnectionOutput {
	return o.ApplyT(func(v *Cluster) ConnectionOutput { return v.Connection }).(ConnectionOutput)
}

func (o ClusterOutput) DeviceClass() pulumi.StringPtrOutput {
	return o.ApplyT(func(v *Cluster) pulumi.StringPtrOutput { return v.DeviceClass }).(pulumi.StringPtrOutput)
}

func (o ClusterOutput) Name() pulumi.StringOutput {
	return o.ApplyT(func(v *Cluster) pulumi.StringOutput { return v.Name }).(pulumi.StringOutput)
}

func (o ClusterOutput) NodeIds() pulumi.StringArrayOutput {
	return o.ApplyT(func(v *Cluster) pulumi.StringArrayOutput { return v.NodeIds }).(pulumi.StringArrayOutput)
}

func (o ClusterOutput) Replicas() pulumi.IntPtrOutput {
	return o.ApplyT(func(v *Cluster) pulumi.IntPtrOutput { return v.Replicas }).(pulumi.IntPtrOutput)
}

func (o ClusterOutput) Status() pulumi.StringOutput {
	return o.ApplyT(func(v *Cluster) pulumi.StringOutput { return v.Status }).(pulumi.StringOutput)
}

func init() {
	pulumi.RegisterInputType(reflect.TypeOf((*ClusterInput)(nil)).Elem(), &Cluster{})
	pulumi.RegisterOutputType(ClusterOutput{})
}
